=== debian/changelog ===
obs-studio (29.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 29.0.2+dfsg
  * Re-generated d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 11 Feb 2023 15:55:47 +0100

obs-studio (29.0.0+dfsg1-2) unstable; urgency=medium

  * B-D on libopengl-dev rather than libgl-dev
  * Restructure d/rules with execute_(before,after)_dh_*
  * Filter out '.git*' files and directories (for future imports)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 26 Jan 2023 11:08:02 +0100

obs-studio (29.0.0+dfsg1-1) unstable; urgency=medium

  * New upstream version 29.0.0+dfsg1
    (Closes: #1023964)

  [ Debian Janitor ]
  * Apply multi-arch hints. + obs-plugins: Add Multi-Arch: same.

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Refresh patches with 'gbp pq'
  * Suggest 'pkexec' instead of 'policykit-1' (Closes: #1025594)
  * Replace obsolete B-Ds with their modern counterparts
  * Add 'libva-dev' to the B-Ds
  * Update d/libobs0.symbols
  * Add myself to uploaders
  * Update d/copyright
    + Modernize 'licensecheck' target
    + Re-generate d/copyright_hints
  * Update d/watch
    + Properly handle pre-releases
    + Drop repack-count (for future imports)
  * Apply 'wrap-and-sort -ast'
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 25 Jan 2023 17:07:16 +0100
